/* mod_activex - remove ActiveX OBJECTs from HTML pages
*/

#include "squid.h"
#include "module.h"
#include "htmlfilter.h"
#include "patfile.h"

#define MODNAME         "mod_activex"

#define ACTIVEX_C
#include <classes.dh>

static char *fake_attrs[] = { "OBJECT", "COMMENT" };
static char *fake_valus[] = { NULL, "\"ACTIVEX_REMOVED_BY_PROXY\"" };
#define fake_nattribs 2

static int activexProcessTag(htmlFilterObject *cf, MemBuf *target,
                            int nattribs, char *attrs[], char *valus[])
{
    int i;

    /* Opening OBJECT: defang ActiveX classid */
    if (!strcasecmp(attrs[0], "OBJECT"))
        for (i=1; i<nattribs; ++i)
            if (attrs[i] && valus[i] &&
                !strcasecmp(attrs[i], "CLASSID")) {
                char *p = valus[i];
                if (!strncasecmp(p, "CLSID:", 6)) {
                    debug(93, 3) (MODNAME ": %s: removing activex OBJECT\n",
                                  moduleUrlClean(cf->uri));
                    insertTag(cf, target, fake_nattribs, fake_attrs, fake_valus);
                    return 1;
                }
            }

    return 0;
}

CBDATA_TYPE(htmlModuleObject);

void moduleInit(const wordlist *args)
{
    htmlModuleObject *m;
    patFileObject *pf;

    CBDATA_INIT_TYPE(htmlModuleObject);
    m = new(htmlModuleObject);
    pf = args ? patfileNew(args->key, 0) : NULL;

    m->patFile = REF(pf);
    m->processTag = activexProcessTag;
    htmlfilterRegister(m, "ActiveX filter");
}
